<?php
/*
Plugin Name: Psli-BingMaps
Author: psli 
Description: Admin function for plugin "Psli-BingMaps"
*/

// Chech whether we are indeed included by Piwigo.
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

// Hook on to event on administration page.
add_event_handler('get_admin_plugin_menu_links', 'PSLIBINGMAPS_admin_menu');

// Hook on to event on category page
add_event_handler('loc_end_cat_modify', 'PSLIBINGMAPS_Add_Category_Prefilter', 55);
add_event_handler('loc_end_cat_modify', 'PSLIBINGMAPS_Category_Process');

/********************************************************************************************/
// Process localisation data on category page for Psli-BingMaps plugin
/********************************************************************************************/
function PSLIBINGMAPS_Category_Process()
{	
	// Process click on submit button
	if (isset($_POST['pslibingmapssubmitremove']))
	{
		if  (($_POST['pslibingmapsentity'] != "--null--") and ($_POST['pslibingmapssubmitremovecheck'] == "on"))
		{			
			$q = '
				DELETE FROM '.PSLI_ENTITIES_TABLE.' 					
					WHERE id = '.$_POST['pslibingmapsentity'].';';
			pwg_query($q);
			
			$q = '
				DELETE FROM '.PSLI_DATAPOINT_TABLE.' WHERE id_entity = '.$_POST['pslibingmapsentity'].';';
			pwg_query($q);
		}
	}
	
	if (isset($_POST['pslibingmapssubmitcategory']))
	{		
		if ($_POST['pslibingmapsentity'] == "--null--")
		{
			$q = '
				INSERT INTO '.PSLI_ENTITIES_TABLE.' (lat, lon, action, zoomMin, zoomMax, title, id_category)
					VALUES ('
						.$_POST['pslibingmapslat'].', '
						.$_POST['pslibingmapslon'].', '
						.$_POST['pslibingmapsselect'].', '
						.$_POST['pslibingmapszoommin'].', '
						.$_POST['pslibingmapszoommax'].", '".addslashes($_POST['pslibingmapsname'])."', "
						.$_GET['cat_id'].');';
			pwg_query($q);
		}
		else
		{
			$q = '
				UPDATE '.PSLI_ENTITIES_TABLE.' 
					SET lat = '.$_POST['pslibingmapslat'].', 
						lon = '.$_POST['pslibingmapslon'].', 
						action = '.$_POST['pslibingmapsselect'].',
						zoomMin = '.$_POST['pslibingmapszoommin'].', 
						zoomMax = '.$_POST['pslibingmapszoommax'].", 
						title = '".addslashes($_POST['pslibingmapsname'])."'
					WHERE id = ".$_POST['pslibingmapsentity'].';';
			pwg_query($q);
			
			if ($_POST['pslibingmapszone'] != "--null--")
			{
				$q = '
					DELETE FROM '.PSLI_DATAPOINT_TABLE.' WHERE id_entity = '.$_POST['pslibingmapsentity'].';';
				pwg_query($q);				
				
				if ($_POST['pslibingmapszone'] != "delete all")
				{
					$q = '
						INSERT INTO '.PSLI_DATAPOINT_TABLE.' (id_entity, lat, lon)
							VALUES '.$_POST['pslibingmapszone'];
					pwg_query($q);
				}
			}
		}				
	}
	
	// Initialize data on the fieldset "Psli Bing Maps"
	if (isset($_GET['cat_id']))
	{
		global $template, $prefixeTable;
		
		// Extract data fro this entities
		$query_entity = '
			select id, lat, lon, zoomMin, zoomMax, action 
				FROM '.PSLI_ENTITIES_TABLE.'
				WHERE id_category = '.$_GET['cat_id'].'
				;';
		$result_entity = pwg_query($query_entity);
		$query_category = '
			SELECT name 
				FROM piwigo_categories
				WHERE id = '.$_GET['cat_id'].'
				;';
		$result_category = pwg_query($query_category);
		$row_category = pwg_db_fetch_assoc($result_category);
		
		// Data for this entity already in the table ?
		if (pwg_db_num_rows($result_entity) > 0)
		{
			$row_entity = pwg_db_fetch_assoc($result_entity);
		
			$template->assign(
			array(
				'PSLIBINGMAPSLAT' => $row_entity['lat'],
				'PSLIBINGMAPSLON' => $row_entity['lon'],
				'PSLIBINGMAPSZOOMMIN' => $row_entity['zoomMin'],
				'PSLIBINGMAPSZOOMMAX' => $row_entity['zoomMax'],
				'PSLIBINGMAPSACTION' => $row_entity['action'],
				'PSLIBINGMAPID' => $row_entity['id'],
				'PSLIBINGMAPNAME' => $row_category['name']
			));
			$psli_id = $row_entity['id'];
		}
		else	
		{			
			$template->assign(
			array(
				'PSLIBINGMAPSLAT' => 0,
				'PSLIBINGMAPSLON' => 0,
				'PSLIBINGMAPSZOOMMIN' => 1,
				'PSLIBINGMAPSZOOMMAX' => 20,
				'PSLIBINGMAPSACTION' => 0,				
				'PSLIBINGMAPID' => "--null--",
				'PSLIBINGMAPNAME' => $row_category['name']
			));
			$psli_id = "--null--";
		}
	}
	
	
	if ($psli_id == "--null--")
	{
		$initialView = "psli_g_Map.entities.clear();";
	}
	else
	{
		$query_datapoint = '
			SELECT lat, lon
				FROM '.PSLI_DATAPOINT_TABLE.'
				WHERE id_entity = '.$psli_id.' ORDER BY id;'	;
		$result_datapoint = pwg_query($query_datapoint);
		if (pwg_db_num_rows($result_datapoint) > 0)
		{
			$initialView = "";
			while ($row = pwg_db_fetch_assoc($result_datapoint))
			{
				$initialView .= 'psli_g_VerticeInitial.push(new Microsoft.Maps.Location('.$row['lat'].','.$row['lon'].'));'."\n";
			}
			$initialView .= '
			psli_CopyInitial();
			var psli_l_Pin = new Microsoft.Maps.Polygon(psli_g_Vertice,{fillColor: psli_g_PolygonColor, strokeColor: psli_g_PolygonColor});
			psli_g_Map.entities.clear();
			psli_g_Map.entities.push(psli_l_Pin);
			psli_g_ZoneDraw = true;
			document.getElementById("pslibingmapsbuttonall").disabled = false;
			document.getElementById("pslibingmapsbuttondelete").disabled = false;
			document.getElementById("pslibingmapsbuttonsave").disabled = false;
			document.getElementById("pslibingmapsbuttoncancel").disabled = false;
			document.getElementById("pslibingmapsbuttonstart").disabled = true;
			'."\n";
		}
		else
		{
			$initialView = '
			var psli_l_Pin = new Microsoft.Maps.Pushpin(new Microsoft.Maps.Location(document.getElementById("pslibingmapslat").value, document.getElementById("pslibingmapslon").value));
			psli_g_Map.entities.clear();
			psli_g_Map.entities.push(psli_l_Pin);'."\n";			
		}
	}
	
	$query = '
		SELECT value
			FROM '.CONFIG_TABLE.'
			WHERE param = "'.PSLI_CONF_KEY.'";';
	$result = pwg_query($query);
	$row = pwg_db_fetch_assoc($result);
	$template->assign(
		array(
			'PSLIBINGMAPSKEY' => $row['value'],
			'PSLIBINGMAPSVIEW' => $initialView,
		));
		
	// Language data
	load_language('plugin.lang', PSLI_BINGMAPS_DIRECTORY);
}

/********************************************************************************************/
// function to add prefilter on categories rendering
/********************************************************************************************/
function PSLIBINGMAPS_Add_Category_Prefilter()
 {
	global $template;
	$template->set_prefilter('categories', 'PSLIBINGMAPS_Category_Prefilter_1_1');
 }

/********************************************************************************************/
// Function prefilter on categories rendering
// Add fieldset with data for Psli-BingMaps plugin
/********************************************************************************************/
function PSLIBINGMAPS_Category_Prefilter_1_1($content, &$smarty)
{	
	$search = '#name="reset">
</p>#';
  
	$replacement = 'name="reset">
</p>
    
  	<div>
		<form method="post" >
			<fieldset>
				<legend>{\'Localisation - Plugin Psli-BingMaps\'|@translate}</legend>
				<table style="margin-bottom:10px;width:95%;">
					<colgroup>
						<col width="150px">
						<col width="210px">
						<col width="50px">
						<col width="*">
						<col width="*">
					</colgroup>
					<tr>
						<td>{\'Latitude\'|@translate}&nbsp;:</td>
						<td><input id="pslibingmapslat" type="text" name="pslibingmapslat" value="{$PSLIBINGMAPSLAT}" style="width:200px;" maxlength="21" /></td>
						<td>&nbsp;</td>
						<td style="text-align:right;">						
							<button id="pslibingmapsbuttonstart" style="width:180px;" type="button" onclick="psli_StartZone();" DISABLED>{\'Creer une zone\'|@translate}</button>
						</td>
						<td style="text-align:left;">
							<button id="pslibingmapsbuttondelete" style="width:180px;" type="button" onclick="psli_DeleteLast();" DISABLED>{\'Supprimer le dernier point\'|@translate}</button>
						</td>	
					</tr>
					<tr>
						<td>{\'Longitude\'|@translate}&nbsp;:</td>
						<td>
							<input id="pslibingmapslon" type="text" name="pslibingmapslon" value="{$PSLIBINGMAPSLON}" style="width:200px;" maxlength="21">					
						</td>
						<td>&nbsp;</td>
						<td style="text-align:right;">
							<button id="pslibingmapsbuttonsave" style="width:180px;" type="button" onclick="psli_SaveZone();" DISABLED>{\'Enregistrer la zone\'|@translate}</button>
							<input id="pslibingmapszone" type="hidden" name="pslibingmapszone" value="--null--" />
						</td>
						<td style="text-align:left;">
							<button id="pslibingmapsbuttonall" style="width:180px;" type="button" onclick="psli_DeleteAll();" DISABLED>{\'Tout effacer\'|@translate}</button>
						</td>
					</tr>
					<tr>
						<td>{\'Zoom minimum\'|@translate}&nbsp;:</td>
						<td>
							<input id="pslibingmapszoommin" type="text" name="pslibingmapszoommin" value="{$PSLIBINGMAPSZOOMMIN}" style="width:200px;margin-right:5px;" maxlength="2">
						</td>
						<td style="text-align:left;">
							<button type="button" onclick="psli_SetMinimum();">{\'Set\'|@translate}</button>
						</td>	
						<td style="text-align:right;">						
							<button id="pslibingmapsbuttoncancel" style="width:180px;" type="button" onclick="psli_CancelZone();" DISABLED>{\'Annuler le mode creation\'|@translate}</button>
						</td>	
					</tr>
					<tr>
						<td>{\'Zoom maximum\'|@translate}&nbsp;:</td>
						<td>
							<input id="pslibingmapszoommax" type="text" name="pslibingmapszoommax" value="{$PSLIBINGMAPSZOOMMAX}" style="width:200px;margin-right:5px;" maxlength="2">
						</td>	
						<td style="text-align:left;">						
							<button type="button" onclick="psli_SetMaximum();">{\'Set\'|@translate}</button>					
						</td>			
					</tr>
					<tr>
						<td>{\'Action\'|@translate}&nbsp;:</td>
						<td>
							<select id="pslibingmapsselect" name="pslibingmapsselect" style="width:200px;" >
								<option value="0">{\'Contenu\'|@translate}</option>
								<option value="1">{\'Zoom niveau 1\'|@translate}</option>
								<option value="2">{\'Zoom niveau 2\'|@translate}</option>
								<option value="3">{\'Zoom niveau 3\'|@translate}</option>
								<option value="4">{\'Zoom niveau 4\'|@translate}</option>
								<option value="5">{\'Zoom niveau 5\'|@translate}</option>
								<option value="6">{\'Zoom niveau 6\'|@translate}</option>
								<option value="7">{\'Zoom niveau 7\'|@translate}</option>
								<option value="8">{\'Zoom niveau 8\'|@translate}</option>
								<option value="9">{\'Zoom niveau 9\'|@translate}</option>
								<option value="10">{\'Zoom niveau 10\'|@translate}</option>
								<option value="11">{\'Zoom niveau 11\'|@translate}</option>
								<option value="12">{\'Zoom niveau 12\'|@translate}</option>
								<option value="13">{\'Zoom niveau 13\'|@translate}</option>
								<option value="14">{\'Zoom niveau 14\'|@translate}</option>
								<option value="15">{\'Zoom niveau 15\'|@translate}</option>
								<option value="16">{\'Zoom niveau 16\'|@translate}</option>
								<option value="17">{\'Zoom niveau 17\'|@translate}</option>
								<option value="18">{\'Zoom niveau 18\'|@translate}</option>
								<option value="19">{\'Zoom niveau 19\'|@translate}</option>
								<option value="20">{\'Zoom niveau 20\'|@translate}</option>
							</select>
						</td>
						<td style="text-align:left;">														
							<button type="button" onclick="psli_SetAction();">{\'Set\'|@translate}</button>					
						</td>
						<td>&nbsp;</td>	
						<td style="text-align:left;">						
							<input name="pslibingmapssubmitremove" style="width:180px;" type="submit" value="{\'Supprimer la localisation\'|@translate}" {$TAG_INPUT_ENABLED} />
							<input type="checkbox" name="pslibingmapssubmitremovecheck">{\'Etes-vous sur ?\'|@translate}</input>
						</td>						
					</tr>
					<tr>
						<td colspan="5" style="text-align:center;">
							<input id="pslibingmapsaction" type="hidden" name="pslibingmapsaction" value="{$PSLIBINGMAPSACTION}" />
							<input id="pslibingmapsname" type="hidden" name="pslibingmapsname" value="{$PSLIBINGMAPNAME}" />
							<input id="pslibingmapsentity" type="hidden" name="pslibingmapsentity" value="{$PSLIBINGMAPID}" />
							<input class="submit" name="pslibingmapssubmitcategory" type="submit" value="{\'Valider\'|@translate}" {$TAG_INPUT_ENABLED} />							
						</td>
					</tr>
				</table>
				<div id=\'pslibingmapsmap\' style="position:relative; text-align:center; height:439px; margin-bottom:15px; margin-right:15px; margin-left:15px; border:2px solid white">
				</div>
				<script charset="UTF-8" type="text/javascript" src="http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0"></script>			   		   
				<script charset="UTF-8" type="text/javascript" src="./plugins/Psli-BingMaps/JS/Psli-BingMaps.js"></script>			   
				<script>		
				psli_g_BingKey = "{$PSLIBINGMAPSKEY}";
				psli_InitCategoryMap();				
				{$PSLIBINGMAPSVIEW}
				</script>
			</fieldset>
		</form>
	</div>
  ';

  return preg_replace($search, $replacement, $content);
 }

/********************************************************************************************/
// Add an entry to the 'Plugins' menu.
/********************************************************************************************/
function PSLIBINGMAPS_admin_menu($menu) {
 array_push(
   $menu,
   array(
     'NAME'  => 'PSLI-BingMaps',
     'URL'   => get_admin_plugin_menu_link(PSLI_BINGMAPS_DIRECTORY.'include/admin.php')
   )
 );
 return $menu;
}

?>