<?php
/*
Plugin Name: Psli-BingMaps
Author: psli 
Description: Admin function for plugin "Psli-BingMaps"
*/

// Chech whether we are indeed included by Piwigo.
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

// Get configuration
global $conf;
$query = '
	SELECT value
		FROM '.CONFIG_TABLE.'
		WHERE param = "'.PSLI_CONF_KEY.'";';
$result = pwg_query($query);
$row = pwg_db_fetch_assoc($result);
$conf[PSLI_CONF_KEY] = $row['value'];
$query = '
	SELECT value
		FROM '.CONFIG_TABLE.'
		WHERE param = "'.PSLI_CONF_LAT.'";';
$result = pwg_query($query);
$row = pwg_db_fetch_assoc($result);
$conf[PSLI_CONF_LAT] = $row['value'];
$query = '
	SELECT value
		FROM '.CONFIG_TABLE.'
		WHERE param = "'.PSLI_CONF_LON.'";';
$result = pwg_query($query);
$row = pwg_db_fetch_assoc($result);
$conf[PSLI_CONF_LON] = $row['value'];
$query = '
	SELECT value
		FROM '.CONFIG_TABLE.'
		WHERE param = "'.PSLI_CONF_ZOOM.'";';
$result = pwg_query($query);
$row = pwg_db_fetch_assoc($result);
$conf[PSLI_CONF_ZOOM] = $row['value'];
$query = '
	SELECT value
		FROM '.CONFIG_TABLE.'
		WHERE param = "'.PSLI_CONF_CATEGORY.'";';
$result = pwg_query($query);
$row = pwg_db_fetch_assoc($result);
$conf[PSLI_CONF_CATEGORY] = $row['value'];

$conf['psli_already_done'] = false;

		
// Hook to category description event
add_event_handler('render_category_description', 'PSLIBINGMAPS_Process_Album');

/********************************************************************************************/
// Process data when album is shown
/********************************************************************************************/
function PSLIBINGMAPS_Process_Album($desc) {
	global $conf, $page;
	
	// ie6 ? end here
	if (! (strpos($_SERVER['HTTP_USER_AGENT'],"MSIE 6.0") === FALSE))
		return $desc;
		
	// First test album to control availabilty of the map
	if ((isset($page['category']['id'])) and  ($page['category']['id'] == $conf[PSLI_CONF_CATEGORY]) and ($conf['psli_already_done'] == false))
	{	
	
		// Language data
		load_language('plugin.lang', PSLI_BINGMAPS_DIRECTORY);
		
		$conf['psli_already_done'] = true;
		$desc .= "\n".'
<!-- PSLI Bing Maps Start -->		
<style type="text/css">.thumbnailCategories { display:none; }</style>
<div id=\'Coordonates\' style="color: #ffff80; font-size:120%; font-weight:bold; position:relative; margin-top:30px; width:100%; height:30px;">
</div>
<div id=\'myMap\' style="position:relative; text-align:center; height:600px; margin-bottom:15px; margin-right:15px; margin-left:15px; border:2px solid white">
</div>
<script charset="UTF-8" type="text/javascript" src="http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0"></script>			   
<script charset="UTF-8" type="text/javascript" src="./plugins/Psli-BingMaps/JS/Psli-BingMaps.js"></script>			   
<script>
psli_g_BingKey = "'.$conf[PSLI_CONF_KEY].'";
psli_g_zoomInitial = '.$conf[PSLI_CONF_ZOOM].';
psli_g_MapCenter = new Microsoft.Maps.Location('.$conf[PSLI_CONF_LAT].', '.$conf[PSLI_CONF_LON].')'."\n";

	
		$query_entities = '
			SELECT id, lat, lon, zoomMin, zoomMax, action, title, id_category
			  FROM '.PSLI_ENTITIES_TABLE.';';
		$result_entities = pwg_query($query_entities);
		
		// Is there any entities ?
		if (pwg_db_num_rows($result_entities) > 0)
		{			
			$desc_data = "";
			$desc_function_mouse_over = "";
			$desc_function_click = "";
		
			// For each sub category
			while ($entity = pwg_db_fetch_assoc($result_entities))
			{					
				$query_datapoint = '
					SELECT lat, lon
						FROM '.PSLI_DATAPOINT_TABLE.'
						WHERE id_entity = '.$entity['id'].' ORDER BY id;';
				$result_datapoint = pwg_query($query_datapoint);
				if (pwg_db_num_rows($result_datapoint) > 0)
				{
					$desc_data .= 'var psli_t_Vertices'.$entity['id'].' = new Array();'."\n";
					while ($row = pwg_db_fetch_assoc($result_datapoint))
					{
						$desc_data .= 'psli_t_Vertices'.$entity['id'].'.push(new Microsoft.Maps.Location('.$row['lat'].','.$row['lon'].'));'."\n";
					}
					$desc_data .= '
	var psli_t_Child'.$entity['id'].' = new Microsoft.Maps.Polygon(psli_t_Vertices'.$entity['id'].',{fillColor: psli_g_PolygonColor, strokeColor: psli_g_PolygonColor});'."\n";

					$desc_function_mouse_over .= '
	function psli_MapsMouseOver_'.$entity['id'].' (e) { 
	  document.getElementById("Coordonates").innerHTML = "'.l10n('Cliquez pour zoomer sur').$entity['title'].'";
	}'."\n";
				}
				else
				{
					$desc_data .= '
	var psli_t_Child'.$entity['id'].' = new Microsoft.Maps.Pushpin(new Microsoft.Maps.Location('.$entity['lat'].','.$entity['lon'].'));'."\n";

					$desc_function_mouse_over .= '
	function psli_MapsMouseOver_'.$entity['id'].' (e) { 
	  document.getElementById("Coordonates").innerHTML = "'.l10n('Cliquez pour acceder aux photos').$entity['title'].'";
	}'."\n";
				}
				
				$desc_data .= '
	Microsoft.Maps.Events.addHandler(psli_t_Child'.$entity['id'].', "mouseover", psli_MapsMouseOver_'.$entity['id'].');
	Microsoft.Maps.Events.addHandler(psli_t_Child'.$entity['id'].', "mouseout", psli_MapsMouseOut);
	Microsoft.Maps.Events.addHandler(psli_t_Child'.$entity['id'].', "click", psli_MapsClick_'.$entity['id'].');'."\n";
	
				if ($entity['action'] == 0)
				{
					$desc_function_click .= '
function psli_MapsClick_'.$entity['id'].' (e) { 
  document.location.href=\'index.php?/category/'.$entity['id_category'].'\';
}'."\n";
				}
				else	
				{
					$desc_function_click .= '
function psli_MapsClick_'.$entity['id'].' (e) { 
  psli_g_Map.setView({zoom:'.$entity['action'].', center: new Microsoft.Maps.Location('.$entity['lat'].', '.$entity['lon'].')});
}'."\n";
				}
			
				for ($i = $entity['zoomMin']; $i <= $entity['zoomMax']; $i++)
				{
					$desc_data .= 'psli_g_ZoomEntity['.($i - 1).'].push(psli_t_Child'.$entity['id'].');'."\n";
				}
			}
			$desc .= $desc_data;
			$desc .= $desc_function_mouse_over;
			$desc .= $desc_function_click;
		}
		$desc .= '
psli_InitGuestMap();
</script>'."\n";	   	
	}
	return $desc;
}
?>